.386 			
.MODEL FLAT,STDCALL
UNICODE=0				;Necessario per la riga sotto... niente unicode, grazie.
INCLUDE W32.inc

extrn WriteConsoleA:Proc		;Procedure che non sono nel W32.inc :(
extrn ReadConsoleA:Proc
extrn SetConsoleTitleA:Proc
extrn GetStdHandle:Proc
extrn wsprintf:Proc

.data

hStdOut dd 0
hStdIn dd 0
Titolo db 'Esempio di operazioni in console',0
TestoDaScrivere db 'Digita il tuo nome: '
DimTestoDaScrivere EQU $-TestoDaScrivere
DatiDaLeggere db 50 dup (?)
DimDatiDaLeggere EQU 50
DatiLetti dd 0
Buffer db 80 dup (?)
TestoDaScrivere2 db 'Piacere di conoscerti, %s',0

.code

start:


	call SetConsoleTitleA, offset Titolo	;Cambiamo il titolo della finestra

	call GetStdHandle, STD_OUTPUT_HANDLE	;Mi trovo l'handle allo standard output della console
	cmp eax, INVALID_HANDLE_VALUE		;In caso la funzione GetStdHandle fallisca... usciamo	
	jz esci

	
	;Poich tutte le funzioni API modificano eax, dobbiamo salvare l'handle appena ottenuto
	;per gli usi futuri....
	;Le funzioni API garantiscono che non verranno modificati i registri di segmento e 
	;ebx, esi, edi e ebp, ma per quanto riguarda gli altri... non potete chiamare una funzione API
 	;e pensare che vi rimetta a posto tutti i registri :)
	mov hStdOut,eax				

	;Tutte le funzioni API tranne la wsprintf usano la convenzione stdcall... noi pushiamo sullo stack
	;i parametri, e la funzione chiamata rimette a posto lo stack prima di ritornare.
	;il quarto parametro  NULL perch a noi non interessa sapere quanti caratteri ha scritto...
	;voglio sperare infatti che me li abbia scritti tutti :)
	call WriteConsoleA, hStdOut, offset TestoDaScrivere, DimTestoDaScrivere, NULL, NULL

	call GetStdHandle, STD_INPUT_HANDLE	;Mi trovo l'handle allo standard input della console
	cmp eax, INVALID_HANDLE_VALUE		;In caso la funzione GetStdHandle fallisca... usciamo	
	jz esci

	mov hStdIn, eax
	
	;Leggiamo qualcosa dalla console
	call ReadConsoleA, hStdIn, offset DatiDaLeggere, DimDatiDaLeggere, offset DatiLetti, NULL
			
	;Questa funzione permette di costruire stringhe agevolmente :)
	call wsprintf, offset Buffer, offset TestoDaScrivere2, offset DatiDaLeggere

	;Questa funzione API  l'unica che non toglie i parametri dallo stack da sola.
	pop ebx
	pop ebx
	pop ebx	

	;il valore di ritorno di wsprintf non tiene conto del nullchar finale, ma io voglio levare
	;il ritorno a capo che  in coda alla stringa, appena prima del nullchar.
	;normalmente non  un problema questo della wsprintf, visto che o sono io che gli dico gi
	;quanto  lunga la stringa (e allora non serve il nullchar) come per la WriteFile, 
	;o io non gli dico la dimensione (i.e.: MessageBoxA) e se lo trova la funzione 
	;da sola il nullchar :)
	dec eax

	;Stavolta usiamo l'altra API. Provate a cambiare la parola File con Console e ricompilate,
	;vedrete che funziona tutto alla perfezione	
	call WriteFile, hStdOut, offset Buffer, eax, NULL, NULL
	

esci:
	;Tutti i programmi Win32 dovrebbero chiamare la ExitProcess per terminare il loro processo.. :)
	;Il parametro passato  il codice di uscita, che pu essere utile per far capire ad altri programmi
	;se tutto  andato bene o no ( come il vecchio errorlevel del DOS)
	call ExitProcess, NULL

ends
end start